% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/functions-XCMSnExp.R
\name{applyAdjustedRtime}
\alias{applyAdjustedRtime}
\title{Replace raw with adjusted retention times}
\usage{
applyAdjustedRtime(object)
}
\arguments{
\item{object}{An \link{XCMSnExp} object.}
}
\value{
A \code{XCMSnExp} with the raw retention times being replaced with the
adjusted retention time.
}
\description{
Replaces the raw retention times with the adjusted retention
time or returns the object unchanged if none are present.
}
\details{
Adjusted retention times are stored \emph{in parallel} to the adjusted
retention times in the \code{XCMSnExp}. The \code{applyAdjustedRtime} replaces the
raw retention times (stored in the \emph{feature data} (\code{fData} \code{data.frame}))
with the adjusted retention times.
}
\note{
Replacing the raw retention times with adjusted retention times
disables the possibility to restore raw retention times using the
\code{\link[=dropAdjustedRtime]{dropAdjustedRtime()}} method. This function does \strong{not} remove the
retention time processing step with the settings of the alignment from
the \code{\link[=processHistory]{processHistory()}} of the \code{object} to ensure that the processing
history is preserved.
}
\seealso{
\code{\link[=adjustRtime]{adjustRtime()}} for the function to perform the alignment (retention
time correction).\preformatted{[adjustedRtime()] for the method to extract adjusted retention times from
an [XCMSnExp] object.

[dropAdjustedRtime] for the method to delete alignment results and to
restore the raw retention times.
}
}
\author{
Johannes Rainer
}
